from browser import window

img = None

def sketch(g):

    g.ufo_x = 50
    g.speed = 1
    g.cow_y = 250
    g.cow_x = 250
    g.cow_speed = 0
    g.cow_x_speed = 0
    g.shadow_width = 60
    g.shadow_height = 30
    g.ufo_shadow_width = 120
    g.ufo_shadow_height = 60
    
    def setup():
        g.createCanvas(500, 300)
        g.noStroke()
        g.rectMode('center')
   
    def draw():
        g.background('black')
        
        draw_grass()
        draw_moon()
        draw_ufo_shadow()
        draw_tractor_beam()
        move_ufo()
        draw_cow_shadow()
        draw_cow()
        draw_ufo()
        
    def draw_grass():
        g.fill('lightgreen')
        g.ellipse(g.width/2, 310, g.width * 2, 150)
        
    def draw_moon():
        g.fill('lightgray')
        g.circle(g.width, -10, g.height/2)
        g.fill('gray')
        g.circle(g.width - 35, 10, 35)
        g.circle(g.width - 15, 35, 20)
        
    def draw_ufo():
        # black square to hide cow
        g.fill('black')
        g.rect(g.ufo_x, g.height/2 - 28, 80, 60)
        # ufo
        g.fill('darkgray')
        g.ellipse(g.ufo_x, g.height/2-10, 40, 25)
        g.fill('gray')
        g.ellipse(g.ufo_x, g.height/2, 80, 20)
        g.fill('lightblue')
        g.ellipse(g.ufo_x, g.height/2 - 15, 20, 5)
        
    def draw_text():
        g.fill('white')
        g.text('thanks', g.ufo_x - 100, g.height/2)
        
    def draw_tractor_beam():
        g.fill(255, 255, 255, 200)
        g.triangle(g.ufo_x - 25, g.cow_y, g.ufo_x + 25, g.cow_y, g.ufo_x, g.height/2)
      
    def move_ufo():
        g.ufo_x += g.speed
        g.cow_y -= g.cow_speed
        g.cow_x += g.cow_x_speed
        if g.ufo_x >= g.width/2:
           g.speed = 0
           g.cow_speed = 0.8
           g.shadow_width += .8
           g.shadow_height += .5
          
        if g.cow_y <= g.height/2 - 15:
           g.cow_speed = 0 
           g.speed = 1
           g.cow_x = g.width + 50
           g.cow_x_speed = 1
           g.shadow_width = 0
           g.shadow_height = 0
           draw_text()
            
    def draw_cow():
        # ears
        g.fill('lightpink')
        g.ellipse(g.cow_x + 30, g.cow_y - 25, 15, 8)
        g.ellipse(g.cow_x + 10, g.cow_y - 25, 15, 8)
        # left legs
        g.fill(220, 220, 220)
        g.ellipse(g.cow_x + 18, g.cow_y + 12, 10, 20)
        g.ellipse(g.cow_x - 10, g.cow_y + 12, 10, 20)
        # udders
        g.fill('lightpink')
        g.ellipse(g.cow_x, g.cow_y + 15, 20, 8)
        # body
        g.fill('white')
        g.ellipse(g.cow_x, g.cow_y, 50, 30)
        # head
        g.ellipse(g.cow_x + 20, g.cow_y - 15, 25, 25)
        # right legs
        g.ellipse(g.cow_x + 10, g.cow_y + 15, 10, 20)
        g.ellipse(g.cow_x - 18, g.cow_y + 15, 10, 20)
        # eyes
        g.fill('black')
        g.ellipse(g.cow_x + 16, g.cow_y - 20, 5)
        g.ellipse(g.cow_x + 26, g.cow_y - 20, 5)
        # nose
        g.fill('lightpink')
        g.ellipse(g.cow_x + 23, g.cow_y - 12, 15, 8)
        g.fill('black')
        # nostrils
        g.ellipse(g.cow_x + 21, g.cow_y - 12, 3, 5)
        g.ellipse(g.cow_x + 25, g.cow_y - 12, 3, 5)
        
    def draw_cow_shadow():
        g.fill(0, 0, 0, 50)
        g.ellipse(g.cow_x, 270, g.shadow_width, g.shadow_height)
        
    def draw_ufo_shadow():
        g.fill(0, 0, 0,50)
        g.ellipse(g.ufo_x, 270, g.ufo_shadow_width * 2, g.ufo_shadow_height * 2)
            
      
    g.setup = setup
    g.draw = draw

window.p5.new(sketch)